import { __name } from '../../chunk-3IXKS7M5.mjs';
import { BucketScope } from '@sapphire/framework';
import { container } from '@sapphire/pieces';
import '../Subcommand.mjs';
import { SubcommandCommandPreConditions } from '../types/Enums.mjs';

function parseSubcommandConstructorPreConditionsCooldown({
  subcommand: command,
  cooldownLimit,
  cooldownDelay,
  cooldownScope,
  cooldownFilteredUsers,
  subcommandMethodName,
  subcommandGroupName,
  preconditionContainerArray
}) {
  const { subcommandDefaultCooldown } = container.client.options;
  const filtered = subcommandDefaultCooldown?.filteredCommands?.includes(
    subcommandGroupName ? `${command.name}.${subcommandGroupName}.${subcommandMethodName}` : `${command.name}.${subcommandMethodName}`
  ) ?? false;
  const limit = cooldownLimit ?? (filtered ? 0 : subcommandDefaultCooldown?.limit ?? 1);
  const delay = cooldownDelay ?? (filtered ? 0 : subcommandDefaultCooldown?.delay ?? 0);
  if (limit && delay) {
    const scope = cooldownScope ?? subcommandDefaultCooldown?.scope ?? BucketScope.User;
    const filteredUsers = cooldownFilteredUsers ?? subcommandDefaultCooldown?.filteredUsers;
    preconditionContainerArray.append({
      name: SubcommandCommandPreConditions.PluginSubcommandCooldown,
      context: { scope, limit, delay, filteredUsers, subcommandGroupName, subcommandMethodName }
    });
  }
}
__name(parseSubcommandConstructorPreConditionsCooldown, "parseSubcommandConstructorPreConditionsCooldown");

export { parseSubcommandConstructorPreConditionsCooldown };
//# sourceMappingURL=subcommandCooldown.mjs.map
//# sourceMappingURL=subcommandCooldown.mjs.map